@ECHO OFF
IF NOT %CTERR%.==. GOTO END
REM #############################################################
REM                CodeTyphon Project 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################


ECHO.
ECHO =====================================================================
ECHO             Build Lazarus for Win32 
ECHO =====================================================================
ECHO.

if NOT EXIST %FPCDIR%\units\i386-win32\rtl\classes.o (
  ECHO INFO: FreePascal Units for Win32 NOT EXIST !!!
  CALL x_FPC_Win32_Build
  IF NOT %CTERR%.==. GOTO ERROR
)

ECHO Extract Lazarus Source...
if NOT EXIST %LAZDIR%\Makefile.fpc (
  ECHO INFO: Lazarus Source NOT EXIST !!!
  CALL x_Lazarus_Exract_Source_from_ZipFile
  IF NOT %CTERR%.==. GOTO ERROR
)

ECHO.
ECHO -------------------------------------------------------
ECHO             Prepare Lazarus Win32 
ECHO -------------------------------------------------------
ECHO.

IF NOT EXIST "%LAZDIR%\bin32\" (
  mkdir "%LAZDIR%\bin32"
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: create "%LAZDIR%\bin32" directory
)

IF EXIST "%LAZDIR%\lazarus.exe" (
  del /F /Q "%LAZDIR%\lazarus.exe"
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: Removed lazarus.exe
)

IF EXIST "%LAZDIR%\startlazarus.exe" (
  del /F /Q "%LAZDIR%\startlazarus.exe"
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: Removed startlazarus.exe
)

IF EXIST "%LAZDIR%\lazbuild.exe" (
  del /F /Q "%LAZDIR%\lazbuild.exe"
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: Removed lazbuild.exe
)

IF EXIST "%LAZDIR%\xxlazarusWin64.txt" (
  del /F /Q "%LAZDIR%\xxlazarusWin64.txt"
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: Removed xxlazarusWin64.txt
)

IF EXIST ..\binSettings\win32\lazarus.exe (
  del /F /Q ..\binSettings\win32\lazarus.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  del /F /Q ..\binSettings\win32\startlazarus.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  del /F /Q ..\binSettings\win32\lazbuild.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: Removed old building settings executables
)

IF EXIST ..\binSettings\win32user\lazarus.exe (
  del /F /Q ..\binSettings\win32user\lazarus.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  del /F /Q ..\binSettings\win32user\startlazarus.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  del /F /Q ..\binSettings\win32user\lazbuild.exe
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: Removed old user settings executables
)

del /F /Q ..\binSettings\win32user\lazarus\*.*
IF NOT ERRORLEVEL 0 GOTO ERROR

copy /Y ..\bin\xxlazarusWin32.txt "%LAZDIR%\"
IF NOT ERRORLEVEL 0 GOTO ERROR

CALL x_Lazarus_Settings_Restore
IF NOT %CTERR%.==. GOTO ERROR

ECHO.
ECHO -------------------------------------------------------
ECHO            Clean Lazarus Win32 
ECHO -------------------------------------------------------
ECHO.
pushd "%LAZDIR%\"
"%FPCDIR%\bin\i386-win32\make.exe" clean
IF NOT ERRORLEVEL 0 GOTO ERROR
popd

ECHO.
ECHO -------------------------------------------------------
ECHO             Compile Lazarus Win32 
ECHO -------------------------------------------------------
ECHO.

pushd "%LAZDIR%\" 
"%FPCDIR%\bin\i386-win32\make.exe" bigide
IF NOT ERRORLEVEL 0 GOTO ERROR
popd  

IF NOT EXIST "%LAZTEMP%\" (
  mkdir "%LAZTEMP%"
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO INFO: created %LAZTEMP% directory
)

CALL x_Lazarus_User_Settings_Save
IF NOT %CTERR%.==. GOTO ERROR

IF EXIST "%LAZDIR%\lazarus.exe" (
  ECHO.
  ECHO ------- Copy Laz32 Executables to Settings -----------
  copy /Y "%LAZDIR%\lazarus.exe" ..\binSettings\win32\
  IF NOT ERRORLEVEL 0 GOTO ERROR
  copy /Y "%LAZDIR%\startlazarus.exe" ..\binSettings\win32\
  IF NOT ERRORLEVEL 0 GOTO ERROR
  copy /Y "%LAZDIR%\lazbuild.exe" ..\binSettings\win32\
  IF NOT ERRORLEVEL 0 GOTO ERROR
  ECHO.
  ECHO INFO: Lazarus32 IDE Build OK. Have fun.
) ELSE (
  ECHO.
  ECHO ??????????????????????????????????????????????????????
  ECHO ERROR: Lazarus32 IDE NOT Build
  ECHO ??????????????????????????????????????????????????????
)

GOTO END

:ERROR
echo ERROR  %0
SET CTERR=1
:END
